// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dynamic_graph_bridge_msgs:srv/RunPythonFile.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "dynamic_graph_bridge_msgs/srv/run_python_file.hpp"


#ifndef DYNAMIC_GRAPH_BRIDGE_MSGS__SRV__DETAIL__RUN_PYTHON_FILE__TRAITS_HPP_
#define DYNAMIC_GRAPH_BRIDGE_MSGS__SRV__DETAIL__RUN_PYTHON_FILE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "dynamic_graph_bridge_msgs/srv/detail/run_python_file__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace dynamic_graph_bridge_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const RunPythonFile_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: input
  {
    out << "input: ";
    rosidl_generator_traits::value_to_yaml(msg.input, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RunPythonFile_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: input
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "input: ";
    rosidl_generator_traits::value_to_yaml(msg.input, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RunPythonFile_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace dynamic_graph_bridge_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dynamic_graph_bridge_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dynamic_graph_bridge_msgs::srv::RunPythonFile_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  dynamic_graph_bridge_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dynamic_graph_bridge_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const dynamic_graph_bridge_msgs::srv::RunPythonFile_Request & msg)
{
  return dynamic_graph_bridge_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<dynamic_graph_bridge_msgs::srv::RunPythonFile_Request>()
{
  return "dynamic_graph_bridge_msgs::srv::RunPythonFile_Request";
}

template<>
inline const char * name<dynamic_graph_bridge_msgs::srv::RunPythonFile_Request>()
{
  return "dynamic_graph_bridge_msgs/srv/RunPythonFile_Request";
}

template<>
struct has_fixed_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<dynamic_graph_bridge_msgs::srv::RunPythonFile_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace dynamic_graph_bridge_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const RunPythonFile_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: result
  {
    out << "result: ";
    rosidl_generator_traits::value_to_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RunPythonFile_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result: ";
    rosidl_generator_traits::value_to_yaml(msg.result, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RunPythonFile_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace dynamic_graph_bridge_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dynamic_graph_bridge_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dynamic_graph_bridge_msgs::srv::RunPythonFile_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  dynamic_graph_bridge_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dynamic_graph_bridge_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const dynamic_graph_bridge_msgs::srv::RunPythonFile_Response & msg)
{
  return dynamic_graph_bridge_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<dynamic_graph_bridge_msgs::srv::RunPythonFile_Response>()
{
  return "dynamic_graph_bridge_msgs::srv::RunPythonFile_Response";
}

template<>
inline const char * name<dynamic_graph_bridge_msgs::srv::RunPythonFile_Response>()
{
  return "dynamic_graph_bridge_msgs/srv/RunPythonFile_Response";
}

template<>
struct has_fixed_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<dynamic_graph_bridge_msgs::srv::RunPythonFile_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace dynamic_graph_bridge_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const RunPythonFile_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RunPythonFile_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RunPythonFile_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace dynamic_graph_bridge_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dynamic_graph_bridge_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dynamic_graph_bridge_msgs::srv::RunPythonFile_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  dynamic_graph_bridge_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dynamic_graph_bridge_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const dynamic_graph_bridge_msgs::srv::RunPythonFile_Event & msg)
{
  return dynamic_graph_bridge_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<dynamic_graph_bridge_msgs::srv::RunPythonFile_Event>()
{
  return "dynamic_graph_bridge_msgs::srv::RunPythonFile_Event";
}

template<>
inline const char * name<dynamic_graph_bridge_msgs::srv::RunPythonFile_Event>()
{
  return "dynamic_graph_bridge_msgs/srv/RunPythonFile_Event";
}

template<>
struct has_fixed_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Event>
  : std::integral_constant<bool, has_bounded_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Request>::value && has_bounded_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<dynamic_graph_bridge_msgs::srv::RunPythonFile_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<dynamic_graph_bridge_msgs::srv::RunPythonFile>()
{
  return "dynamic_graph_bridge_msgs::srv::RunPythonFile";
}

template<>
inline const char * name<dynamic_graph_bridge_msgs::srv::RunPythonFile>()
{
  return "dynamic_graph_bridge_msgs/srv/RunPythonFile";
}

template<>
struct has_fixed_size<dynamic_graph_bridge_msgs::srv::RunPythonFile>
  : std::integral_constant<
    bool,
    has_fixed_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Request>::value &&
    has_fixed_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Response>::value
  >
{
};

template<>
struct has_bounded_size<dynamic_graph_bridge_msgs::srv::RunPythonFile>
  : std::integral_constant<
    bool,
    has_bounded_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Request>::value &&
    has_bounded_size<dynamic_graph_bridge_msgs::srv::RunPythonFile_Response>::value
  >
{
};

template<>
struct is_service<dynamic_graph_bridge_msgs::srv::RunPythonFile>
  : std::true_type
{
};

template<>
struct is_service_request<dynamic_graph_bridge_msgs::srv::RunPythonFile_Request>
  : std::true_type
{
};

template<>
struct is_service_response<dynamic_graph_bridge_msgs::srv::RunPythonFile_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // DYNAMIC_GRAPH_BRIDGE_MSGS__SRV__DETAIL__RUN_PYTHON_FILE__TRAITS_HPP_
